var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import handleSearchRequest from "./handlers/search";
import handleAutocompleteRequest from "./handlers/autocomplete";
class ElasticsearchAPIConnector {
    constructor(config, searchConfig) {
        this.config = config;
        this.searchConfig = searchConfig;
        this.state = {};
    }
    onResultClick() {
        console.error("not implemented");
    }
    onAutocompleteResultClick() {
        console.error("not implemented");
    }
    onSearch(state, queryConfig) {
        return __awaiter(this, void 0, void 0, function* () {
            return handleSearchRequest({
                state,
                queryConfig,
                host: this.config.host,
                index: this.config.index,
                connectionOptions: {
                    apiKey: this.config.apiKey
                },
                queryFields: this.searchConfig.queryFields
            });
        });
    }
    onAutocomplete(state, queryConfig) {
        return __awaiter(this, void 0, void 0, function* () {
            return handleAutocompleteRequest({
                state,
                queryConfig,
                host: this.config.host,
                index: this.config.index,
                connectionOptions: {
                    apiKey: this.config.apiKey
                },
                queryFields: this.searchConfig.queryFields
            });
        });
    }
}
export default ElasticsearchAPIConnector;
